#include <windows.h>
#include <stdio.h>
#include <process.h>

#define NVARS 200
#define NPROGS 1000

void main(int argc, char *argv[])
   {                             // main
   int ifile;
   FILE *fp;
   char compiler[MAX_PATH];
   char *junk;

   SearchPath(NULL, "cl.exe", NULL, sizeof(compiler), compiler, &junk);

   for (ifile = 0; ifile < NPROGS; ++ifile)
      {                          // for each file
      char filename[13];
      int i;
      int errorlevel;

      sprintf(filename, "junk%3.3d.obj", ifile);
      if ((fp = fopen(filename, "r")))
         {                       // file exists
         fclose(fp);
         continue;
         }                       // file exists
      sprintf(filename, "junk%3.3d.c", ifile);
      fp = fopen(filename, "w");

      if (ifile < NPROGS -1)
         {                       // not last file
         fprintf(fp, "extern void Init%3.3d(void);\n", ifile+1);
         fprintf(fp, "void Init%3.3d(void){Init%3.3d();}\n", ifile, ifile+1);
         }                       // not last file
      else
         fprintf(fp, "void Init%3.3d(void){}\n", ifile);

      fprintf(fp, "int junk%3.3d(int *p){\nint sum = 0;\n", ifile);

      for (i = 0; i < NVARS; ++i)
         fprintf(fp, "int a%d = *p++;\n", i);
      for (i = 0; i < NVARS; ++i)
         fprintf(fp, "sum += a%d;\n", i);

      fputs("return sum;}\n", fp);
      fclose(fp);

      errorlevel = spawnl(P_WAIT, compiler, compiler,
         "-nologo","-Gy", "-Gh", "-Zd", "-c", filename, NULL);
      if (errorlevel)
         {                       // error compiling
         printf("Error return %d trying to compile %s\n", errorlevel, filename);
         exit(1);
         }                       // error compiling
      remove(filename);
      }                          // for each file
   fp = fopen("pagwaste.lnk", "w");
   for (ifile = 0; ifile < NPROGS; ++ifile)
      fprintf(fp, "junk%3.3d.obj\n", ifile);
   }                             // main
